<?php

$script_mode = TRUE;
include ('inc/init.php');

header('Content-Type: application/json');

function object_list($realm, $type = false) {
  $objects = scanRealmByText($realm);

  $output = array();
  switch($realm) {
    case 'ipv4net':
      foreach($objects as $object) {
        array_push(
          $output,
          array(
            $object['name'] => $object['ip'].'/'.$object['mask']
          )
        );
      }
      break;
    case 'object':
      foreach($objects as $object) {
        array_push(
          $output,
          $object['name']
        );
      }
      break;
    default:
      return false;
  }

  return json_encode($output);
}

switch($_GET['handler']) {
  case 'netlist':
    print object_list('ipv4net');
    break;
  case 'hostlist':
    print object_list('object');
    break;

  case 'newObject':
    assertUIntArg('object_type_id');
    assertStringArg('name');
    assertStringArg('label', TRUE);

    try {
      $object_id = commitAddObject(
        $_REQUEST['name'],
        $_REQUEST['label'],
        $_REQUEST['object_type_id'],
        $_REQUEST['taglist']
      );

      print json_encode(array(
        'status' => 'ok',
        'object_id' => $object_id
      ));
    } catch (InvalidRequestArgException $e) {
      print json_encode(array(
        'status' => 'error',
        'reason' => $e->getMessage()
      ));
    }
    break;
  default:
    header('HTTP/1.1 404 Not Found');
    print json_encode(array(
      'status' => 'error',
      'reason' => 'No such handler'
    ));
    break;
}

?>
